void OSystem_SDL_Common::move_screen(int dx, int dy, int height) {

	if ((dx == 0) && (dy == 0))
		return;

	/* FIXME: undraw mouse only if the draw rect intersects with the mouse rect */
	if (_mouse_drawn)
		undraw_mouse();

	if (SDL_LockSurface(sdl_screen) == -1)
		error("SDL_LockSurface failed: %s.\n", SDL_GetError());

	int offset = dx + dy * SCREEN_WIDTH;
	byte *src;
	
	int w;
	int pitch;

	if (dy < 0)
		w = SCREEN_WIDTH + dy;
	else
		w = SCREEN_WIDTH - dy;
	
	if (offset > 0) {
		// bottom to top
		src = (byte *)sdl_screen->pixels + SCREEN_WIDTH * (SCREEN_HEIGHT - 1);
		pitch = -SCREEN_WIDTH;
	} else if (offset < 0) {
		// top to bottom
		src = (byte *)sdl_screen->pixels - offset;
		pitch = SCREEN_WIDTH;
	}

	do {
		memmove(src + offset, src, w);
		src += pitch;
	} while (--height);

	SDL_UnlockSurface(sdl_screen);
}
